
/********************************************************************
*		ORDER		: ʣץ
*							- ƥץ -
*
*		AUTHOR		: FUJI Data System Corporation
*		CREATE		: 1992.09.01
*		UPDATE		: xxxx.xx.xx
*********************************************************************/

#include	<TK2/TK.h>
#include	<TK2/TKusr.h>
#include    <signal.h>

#include	"mesgid.h"
#include	"gamen1.h"

	int		pr_mesg_recv();
	void    pr_child_close();

	Ktroot	*root;
	Ktcore	*core;

	int		pid;				/* ҥѥͥΥץɣ	*/
	Window	child_wid;			/* ҥѥͥΥɥɣ	*/

/********************************************************************
*		ؿ :	ᥤؿ
*********************************************************************/

void	main()
{
	int		sts = 0;


	signal( SIGCLD, pr_child_close );	/* ʥϿ	*/

	root = (Ktroot *)TKinit();
	if( root != NULL )
	{
		core = (Ktcore *)TKopen( root, NULL, &panel1 );
		if( core != NULL )
		{
			TKentry( core, KARRAY, panel1_tree );
			TKnotify( core, KMESG, pr_mesg_recv );

			while( sts != 1 )
			{
				sts = TKevent( root );
			}
		}
		TKexit( root );
	}
}

/********************************************************************
*		ؿ :	ҥץưܥϣν
*********************************************************************/

int		pr_child_button_on( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		pid = CWexec( "child", core->kit, 0, 0, 0, 0, 0 );
		if( pid > 0 )
		{					/* 봰λ							*/
							/*ޤҥѥͥ뤬ϣУţΤʬǤϤʤ*/
							/*åǳ					*/
			printf( "Child PID = %d\n", pid );
		}else
		{					/* ưǤʤäΤǥܥ夲	*/
			button->flg = OFF;
			TKdisplay( core, KSINGL, button );
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ҥץưܥϣƣƽ
*********************************************************************/

int		pr_child_button_off( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;
	int		pid;


	if( event == ButtonPress )
	{
		if( child_wid > 0 )
		{									/* ҥѥͥạ̃ϣӣ	*/
			TKkill( core, child_wid );
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	å
*********************************************************************/

int		pr_mesg_recv( core, id, wid, data )

	Ktcore	*core;
	int		id;
	Window	wid;
	char	*data;
{
	int		sts = 0;


	switch( id )
	{
		case WID:					/* ҥѥͥ륦ɥɣļ	*/
			child_wid = wid;
			break;
		case END:					/* ҥѥͥ뽪λ					*/
			child_wid = 0;
			button1.flg = OFF;
			TKdisplay( core, KSINGL, &button1 );
			break;
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ҥץλʥ
*********************************************************************/

void	pr_child_close( sig, code, scp )

	int		sig;
	int		code;
	struct sigcontext	*scp;
{
	int		pid;


#if 0
    printf( "sig            = %d\n", sig );
    printf( "code           = %d\n", code);
    printf( "scp.sc_onstack = %d\n",scp->sc_onstack );
    printf( "scp.sc_mask    = %d\n",scp->sc_mask );
    printf( "scp.sc_sp      = %d\n",scp->sc_sp );
    printf( "scp.sc_fp      = %d\n",scp->sc_fp );
#endif

	pid = wait(0);
    printf( "Killed PID = %d\n", pid );

	TKsend( NULL, core->kit, END, NULL, 0 );

    signal( SIGCLD, pr_child_close );
}

