
/********************************************************************
*		ORDER		: إեȼ̤ɲá
*
*		AUTHOR		: FUJI Data System Corporation
*		CREATE		: 1992.09.01
*		UPDATE		: xxxx.xx.xx
*********************************************************************/

#include	<TK2/TK.h>
#include	<TK2/TKusr.h>
#include	<sys/stat.h>

#include	"gamen.h"

	void	pr_initial();

	Ktroot	*root;
	Ktcore	*core;

	Ktbutn	*select_button = NULL;		/* ߲Ƥܥ	*/
	char	**list;						/* ե̾ΤǼ		*/
	int		view_line = -1;				/* ƬΤβܤ	*/
	int		view_clum = 0;				/* üϲܤ		*/
	int		view_select = -1;			/* 򤷤Ƥ			*/
	char	*select_font = NULL;		/* 򤷤Ƥե̾	*/
	char	*ank = NULL;				/* ANKΥե̾		*/
	char	*kanji = NULL;				/* Υե̾		*/

	Kttext	*list_tree[] =				/* ե̾ΰARRAY	*/
	{
		&Text1,
		&Text2,
		&Text3,
		&Text4,
		&Text5,
		&Text6,
		&Text7,
		&Text8,
		&Text9,
		&Text10,
		&Text11,
		&Text12,
		&Text13,
		&Text14,
		&Text15,
		&Text16,
		NULL
	};

/********************************************************************
*		ؿ :	ᥤؿ
*********************************************************************/

void	main()
{
	int		sts = 0;


	pr_initial();

	root = (Ktroot *)TKinit();
	if( root != NULL )
	{
		core = (Ktcore *)TKopen( root, NULL, &panel );
		if( core != NULL )
		{
			TKentry( core, KARRAY, panel_tree );

			while( sts != 1 )
			{
				sts = TKevent( root );
			}
		}
		TKexit( root );
	}
}

/********************************************************************
*		ؿ :	˥
*********************************************************************/

void	pr_initial()
{
	char	command[256];
	char	filename[256];
	char	*text;				/* xlsfontsξɤ߹Хåե	*/
	struct stat	bf_stat;
	int		fd;
	int		size;
	int		cnt;
	int		i, j, l;
	int		line = 0;
	int		clum_max = 0;
										/* ե̾ΰ	*/
										/* ޤ			*/
										/* ϤƤߤƤ	*/
	strcpy( filename, "/tmp/fileXXXXXX" );
	mkstemp( filename );
	sprintf( command, "xlsfonts > %s", filename );
	system( command );

	fd = open( filename, O_RDONLY, 0 );
	if( fd > 0 )
	{
		fstat( fd, &bf_stat );
		size = bf_stat.st_size;
		if( size > 0 )
		{
			text = (char *)malloc( size );
			if( text != NULL )
			{
				cnt = read( fd, text, size );

				for( i=0; i<size; i++ )
				{
					if( text[i] == '\n' )
					{
						line++;
					}
				}
			}
		}
		close( fd );
	}
	unlink( filename );

	if( line >= 0 )
	{
		list = (char **)malloc( sizeof(char *) * (line+1) );
		if( list != NULL )
		{
			for( l=0,j=0,i=0; i<size; i++ )
			{
				if( text[i] == '\n' )
				{
					text[i] = 0;
					list[l] = (char *)malloc( (i-j)+1 );
					if( list[l] != NULL )
					{
						strcpy( list[l], &text[j] );

						if( (i-j) > clum_max )
							clum_max = i-j;

						l++;
						j = i +1;
					}
				}
			}
			list[l] = NULL;
		}
	}

									/* ĥ뎥С	*/
	sbar_tate.bp = 0;
	pr_sbar_tate( NULL, 0, &sbar_tate );
	sbar_tate.bl = line * 0x10000 + 16;
									/* 뎥С	*/
	sbar_yoko.bp = 0;
	pr_sbar_tate( NULL, 0, &sbar_tate );
	sbar_yoko.bl = clum_max * 0x10000 + Text1.c;

	BoxCursor.y = -2000;			/* Υ̤γ	*/
}

/********************************************************************
*		ؿ :	Σ/ܸܥϣν
*********************************************************************/

int		pr_font_button_on( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		if( select_button != NULL )
		{						/* 󲡤Ƥܥ夲 */
			select_button->flg = OFF;
			TKdisplay( core, KSINGL, select_button );
		}
		select_button = button;	/* ߲줿ܥ		*/
	}

	return( sts );
}

/********************************************************************
*		ؿ :	Σ/ܸܥϣƣƽ
*********************************************************************/

int		pr_font_button_off( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{									/* ܥ夲ʤ	*/
		button->flg = ON;
		TKdisplay( core, KSINGL, button );
	}

	return( sts );
}

/********************************************************************
*		ؿ :	եѹܥ
*********************************************************************/

int		pr_change_button( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;
	int		id_font;


	if( event == ButtonPress )
	{
		if( ( select_button != NULL ) &&
			( view_line >= 0 ) &&
			( view_select >= 0 ) )
		{
			TKerase( core, KSINGL, &Idata1 ); /* ɽ᡼õ	*/
			TKerase( core, KSINGL, &Idata2 );

			switch( select_button->bid )
			{
				case 0:			/* Σ˥ܥ󤬲Ƥ	*/
					ank = select_font;
					break;
				case 1:			/* ܸܥ󤬲Ƥ	*/
					kanji = select_font;
					break;
			}
												/* եȣɣļ	*/
			id_font = TKaddfont( root, ank, kanji );
			Idata1.font = id_font;				/* եȣɣ	*/
			Idata2.font = id_font;

			TKdisplay( core, KSINGL, &Idata1 );	/*ɽ᡼ɽ*/
			TKdisplay( core, KSINGL, &Idata2 );
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ĥ뎥С
*********************************************************************/

int		pr_sbar_tate( core, bp, sbar )

	Ktcore	*core;
	int		bp;
	Ktsbar	*sbar;
{
	int		sts = 0;
	int		i;
	int		len;


	if( view_line != bp )
	{
		view_line = bp;

		if( core != NULL )
		{
			TKerase( core, KSINGL, &BoxCursor );
			TKerase( core, KARRAY, list_tree );
		}

		for( i=0; list_tree[i]!=NULL; i++ )
		{
			len = strlen( list[view_line+i] );
			if( len > view_clum )
				list_tree[i]->text = &list[view_line+i][view_clum];
			else
				list_tree[i]->text = &list[view_line+i][len];
		}

		BoxCursor.y = -2000;
		if( select_font != NULL )
		{
			for( i=0; list_tree[i]!=NULL; i++ )
			{
				if( strcmp( list[view_line+i], select_font ) == 0 )
				{
					BoxCursor.y = i * 16 + Rect1.y + Rect1.wh;
					break;
				}
			}
		}

		if( core != NULL )
		{
			TKdisplay( core, KARRAY, list_tree );
			TKdisplay( core, KSINGL, &BoxCursor );
		}
	}
	return( sts );
}

/********************************************************************
*		ؿ :	뎥С
*********************************************************************/

int		pr_sbar_yoko( core, bp, sbar )

	Ktcore	*core;
	int		bp;
	Ktsbar	*sbar;
{
	int		sts = 0;
	int		i;
	int		len;


	if( view_clum != bp )
	{
		view_clum = bp;

		if( core != NULL )
		{
			TKerase( core, KSINGL, &BoxCursor );
			TKerase( core, KARRAY, list_tree );
		}

		for( i=0; list_tree[i]!=NULL; i++ )
		{
			len = strlen( list[view_line+i] );
			if( len > view_clum )
				list_tree[i]->text = &list[view_line+i][view_clum];
			else
				list_tree[i]->text = &list[view_line+i][len];
		}

		if( core != NULL )
		{
			TKdisplay( core, KARRAY, list_tree );
			TKdisplay( core, KSINGL, &BoxCursor );
		}
	}
	return( sts );
}

/********************************************************************
*		ؿ :	ݥ󥿽 (ޥǥå)
*********************************************************************/

int		pr_pointer( core, x, y, event, poit )

	Ktcore	*core;
	int		x, y;
	int		event;
	Ktpoit	*poit;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		 sts = pr_list_select( core, x, y );
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ࡼֽ (ޥǥࡼ֤)
*********************************************************************/

int		pr_move( core, x, y, move )

	Ktcore	*core;
	int		x, y;
	Ktmove	*move;
{
	int		sts = 0;


	sts = pr_list_select( core, x, y );

	return( sts );
}

/********************************************************************
*		ؿ :	ե̾
*********************************************************************/

int		pr_list_select( core, x, y )

	Ktcore	*core;
	int		x, y;
{
	int		sts = 0;
	int		select;


	select = ( y - Pointer.y ) / 16;

	if( select != view_select )
	{
		view_select = select;
		select_font = (char *)list[view_line+view_select];

		BoxCursor.y = view_select * 16 + Rect1.y + Rect1.wh;
		TKdisplay( core, KSINGL, &BoxCursor );
	}

	return( sts );
}
