/****************************************************************
*                                                               *
*       TITLE       :                                           *
*       FILE NAME   :main.c                                     *
*                                                               *
*       DATE        :1993. 7.26                                 *
*                                                               *
*****************************************************************/


#include       <TK2/TK.h>
#include       <TK2/TKusr.h>
#include       "gamen.h"

Ktroot	*root;
Ktcore	*core;


/****************************************************************
*       FUNCTION NAME   :MAIN PROCEDURE                         *
*****************************************************************/
void    main(agrc,agrv)
int     agrc;
char    *agrv[];
{
    int     sts;


    root = (Ktroot *) TKinit();
    if (root != NULL )
    {
        core = (Ktcore *)TKopen( root, NULL, &panel );
        if (core != NULL)
        {
			button2.flg = ON;
            TKentry( core,KARRAY,panel_tree);
			TKkeysw( core, &Ntext1, KION, -1, -1 );

            for( sts =0;sts != 1; )
            {
                sts = TKevent( root );
            }
        }
        TKexit( root );
    }
}



/****************************************************************
*       Call Back Routine                                       *
*****************************************************************/
int     pr_kinsi_button (core, butn, event)
    Ktcore     *core;
    Ktbutn     *butn;
    int   	    event;

{
    if (event == ButtonRelease)
    {
    } else {
		TKpastlock( ON );
		button2.flg = OFF;
		TKdisplay( core, KSINGL, &button2 );
    }
    return(0);
}


int     pr_kyoka_button (core, butn, event)
    Ktcore     *core;
    Ktbutn     *butn;
    int   	    event;

{
    if (event == ButtonRelease)
    {
    } else {
		TKpastlock( OFF );
		button1.flg = OFF;
		TKdisplay( core, KSINGL, &button1 );
    }
    return(0);
}


int     pr_mode_button_off (core, butn, event)
    Ktcore     *core;
    Ktbutn     *butn;
    int   	    event;

{
    if (event == ButtonPress)
    {
		butn->flg = ON;
		TKdisplay( core, KSINGL, butn );
    }
    return(0);
}


int     pr_getbuff_button (core, butn, event)
    Ktcore     *core;
    Ktbutn     *butn;
    int   	    event;

{
	char		*str;


    if (event == ButtonPress)
    {
		str = (char *)TKgetbuff( core );
		if( str != NULL )
		{
			printf( "Past string = %s\n", str );
			free( str );
		}else
		{
			printf( "Past string nothing.\n" );
		}
    }
    return(0);
}


