
/********************************************************************
*		ORDER		: إϤ缡ܤ
*
*		AUTHOR		: FUJI Data System Corporation
*		CREATE		: 1992.09.01
*		UPDATE		: xxxx.xx.xx
*********************************************************************/

#include	<TK2/TK.h>
#include	<TK2/TKusr.h>

#include	"gamen.h"


	Ktroot	*root;
	Ktcore	*core;

	typedef	struct
	{
		int		id;
		int		esc;
		int		cr;
		int		tab;
		int		bat;
		int		up;
		int		down;
		Ktobj	*obj;
	}ST_SENCE;

	ST_SENCE	tb_sence[] =
	{
		{  0, -1,  1,  1, 11,  8,  4, &Idata0.hed },
		{  1, -1,  2,  2,  0,  9,  5, &Idata1.hed },
		{  2, -1,  3,  3,  1, 10,  6, &Idata2.hed },
		{  3, -1,  4,  4,  2, 11,  7, &Idata3.hed },
		{  4, -1,  5,  5,  3,  0,  8, &Idata4.hed },
		{  5, -1,  6,  6,  4,  1,  9, &Idata5.hed },
		{  6, -1,  7,  7,  5,  2, 10, &Idata6.hed },
		{  7, -1,  8,  8,  6,  3, 11, &Idata7.hed },
		{  8, -1,  9,  9,  7,  4,  0, &Idata8.hed },
		{  9, -1, 10, 10,  8,  5,  1, &Idata9.hed },
		{ 10, -1, 11, 11,  9,  6,  2, &Idata10.hed },
		{ 11, -1,  0,  0, 10,  7,  3, &Idata11.hed },
		{ -1, -1, -1, -1, -1, -1, -1, NULL }
	};	/* |   |   |   |   |   |   |							*/
		/* |   |   |   |   |   |   +----     				*/
		/* |   |   |   |   |   +--------     				*/
		/* |   |   |   |   +------------ Shift+Tab  			*/
		/* |   |   |   +---------------- Tab					*/
		/* |   |   +-------------------- Return					*/
		/* |   +------------------------ Esc					*/
		/* +---------------------------- ʣɣĥ */

/********************************************************************
*		ؿ :	ᥤؿ
*********************************************************************/

void	main()
{
	int		sts = 0;


	root = (Ktroot *)TKinit();
	if( root != NULL )
	{
		core = (Ktcore *)TKopen( root, NULL, &panel );
		if( core != NULL )
		{
			TKentry( core, KARRAY, panel_tree );

			while( sts != 1 )
			{
				sts = TKevent( root );
			}
		}
		TKexit( root );
	}
}

/********************************************************************
*		ؿ :	ǡϽλ
*********************************************************************/

int		pr_keyin( core, idata, type, text )

	Ktcore	*core;
	Ktidata	*idata;
	int		type;
	char	*text;
{
	int		sts = 0;
	int		i;
	int		next_id = -1;
	Ktobj	*keyin;


	for( i=0; tb_sence[i].obj!=NULL; i++ )
	{
		if( tb_sence[i].id == idata->id )
		{
			switch( type )
			{
				case KEYESC:
					next_id = tb_sence[i].esc;
					break;
				case KEYCR:
					next_id = tb_sence[i].cr;
					break;
				case KEYTAB:
					next_id = tb_sence[i].tab;
					break;
				case KEYBAT:
					next_id = tb_sence[i].bat;
					break;
				case KEYUP:
					next_id = tb_sence[i].up;
					break;
				case KEYDW:
					next_id = tb_sence[i].down;
					break;
			}

			if( next_id != -1 )
			{
				for( i=0; tb_sence[i].id!=-1; i++ )
				{
					if( tb_sence[i].id == next_id )
					{
												/* ʼ */
						keyin = tb_sence[i].obj;
												/* Ͼ֣ϣ	*/
						TKkeysw( core, keyin, KION, -1, -1 );
						break;
					}
				}
			}
			break;
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	Ͻλܥ
*********************************************************************/

int		pr_keyoff( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonRelease )
	{
		TKkeyoff( core );
	}

	return( sts );
}
