
/********************************************************************
*		ORDER		: ¾ץΤ줿ǡ򥰥ղ
*							- ƥץ -
*
*		AUTHOR		: FUJI Data System Corporation
*		CREATE		: 1992.09.01
*		UPDATE		: xxxx.xx.xx
*********************************************************************/

#include	<TK2/TK.h>
#include	<TK2/TKusr.h>
#include	<signal.h>
#include	<math.h>

#include	"mesgid.h"
#include	"gamen1.h"

#define		PAI		3.1415926
#define		P		PAI / 180.0

	int		pr_mesg_recv();
	void	pr_alarm();
	void	pr_child_close();

	Ktroot	*root;
	Ktcore	*core;

	Window	child_wid;				/* ҥѥͥ륦ɥɣ		*/
	int		cnt = 0;				/* 飳٤ޤǤΥ */

/********************************************************************
*		ؿ :	ᥤؿ
*********************************************************************/

void	main()
{
	int		sts = 0;


	signal( SIGCLD, pr_child_close );		/* ʥϿ	*/

	root = (Ktroot *)TKinit();
	if( root != NULL )
	{
		core = (Ktcore *)TKopen( root, NULL, &panel1 );
		if( core != NULL )
		{
			TKentry( core, KARRAY, panel1_tree );
										/* åϿ */
			TKnotify( core, KMESG, pr_mesg_recv );

			while( sts != 1 )
			{
				sts = TKevent( root );
			}
		}
		TKexit( root );
	}
}

/********************************************************************
*		ؿ :	ɽϥܥϣν
*********************************************************************/

int		pr_child_button_on( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;
	int		pid;


	if( event == ButtonPress )
	{
												/* ҥץư	*/
		pid = CWexec( "child", core->kit, 0, 0, 0, 0, 0 );
		if( pid > 0 )
		{
		}else
		{					/* ưǤʤäΤǥܥ夲	*/
			button->flg = OFF;
			TKdisplay( core, KSINGL, button );
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ɽϥܥϣƣƽ
*********************************************************************/

int		pr_child_button_off( core, button, event )

	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;
	int		pid;


	if( event == ButtonPress )
	{
		if( child_wid > 0 )
		{										/* ҥץλ	*/
			TKkill( core, child_wid );
			child_wid = NULL;
		}
	}

	return( sts );
}

/********************************************************************
*		ؿ :	å
*********************************************************************/

int		pr_mesg_recv( core, id, wid, data )

	Ktcore	*core;
	int		id;
	Window	wid;
	char	*data;
{
	int		sts = 0;


	switch( id )
	{
		case WID:				/* ҥѥͥ륦ɥɣļ	*/
			child_wid = wid;
			pr_alarm();
			break;
		case END:				/* ҥѥͥ뽪λ	*/
			child_wid = 0;
			button1.flg = OFF;
			TKdisplay( core, KSINGL, &button1 );
			break;
		case DAT:				/* ǡ׵	*/
			pr_alarm();
			break;
	}

	return( sts );
}

/********************************************************************
*		ؿ :	ǡ
*********************************************************************/

void	pr_alarm()
{
	double	dat;


	if( child_wid > 0 )
	{									/* ҥѥͥ˥ǡ	*/
		dat = sin( (double)cnt * P );
		TKsend( core, child_wid, DAT, &dat, sizeof(dat) );

		cnt =  ( cnt + 10 ) % 360;

	}
}

/********************************************************************
*		ؿ :	ҥץλ
*********************************************************************/

void	pr_child_close( sig, code, scp )

	int		sig;
	int		code;
	struct sigcontext	*scp;
{
#if 0
    printf( "sig            = %d\n", sig );
    printf( "code           = %d\n", code);
    printf( "scp.sc_onstack = %d\n",scp->sc_onstack );
    printf( "scp.sc_mask    = %d\n",scp->sc_mask );
    printf( "scp.sc_sp      = %d\n",scp->sc_sp );
    printf( "scp.sc_fp      = %d\n",scp->sc_fp );
#endif

	wait(0);
	TKsend( NULL, core->kit, END, NULL, 0 );

	signal( SIGCLD, pr_child_close );
}
