#include <TK2/TK.h>   
#include <TK2/TKusr.h>   
#include <GR.h>   
#include "kata.h"    
#include "gamen00.h"    
#include "gamen01.h"    
#include "gamen10.h"    
#include "gamen11.h"    
#include "gamen04.h"
#include "gamen51.h"
#include "gamen61.h"
#include "gamen71.h"
#include "HAND"    
#include "HAND_MASK"    

	extern	int	graph_no;
	extern	int	item_no;

	int		k_button_2();
	int     syokika();

	HANBAI hanbai[13];

	Ktroot	*root = {NULL};
	Ktcore	*core00 = {NULL};
	Ktcore	*core_select = {NULL};
	Ktcore	*core_graph = {NULL};
	Ktcore	*core_end = {NULL};
	Ktcore  *core01 = {NULL};
	Ktcore  *core02 = {NULL};
	Ktcore  *core03 = {NULL};
	Ktcore  *core04 = {NULL};
	Grcore	*Gcore = {NULL};
	int		fl_change = {OFF};

	Ktbitmap	tb_cursor_font =
	{
		KBDATA, HAND_width, HAND_height,
		HAND_x_hot,HAND_y_hot,HAND_bits
	};
	Ktbitmap	tb_cursor_mask =
	{
		KBDATA, HAND_MASK_width, HAND_MASK_height,
		HAND_MASK_x_hot,HAND_MASK_y_hot,HAND_MASK_bits
	};
	char	tb_form1[] = {"\\\\99,999,999"};
	char	tb_form2[] = {"999.9\\%"};


	int		pr_panel_exit();

/************************************************************************
*		Module Name	: 													*
*************************************************************************/

void main()
{
	int sts = 0; 
	putenv( "KTISUB=on" );

	root = (Ktroot *)TKinit();  
	if( root != NULL )
	{ 
		core00 = (Ktcore *)TKopen(root,NULL,&panel00);  
		if( core00 != NULL )
		{ 
			TKlabelent(root,panel00_labels);
			TKnotify( core00, KEXIT, pr_panel_exit );

			tb_graph_redrow_button.flg = -1;
			tb_graph_print_button.flg = -1;
			tb_button_exec.flg = -1;

			yomikomi();
			pr_table_init();
			pr_table_data_set();
			pr_hc_initial();

			TKentry(core00,KARRAY,&panel00_tree[0]);
			TKchgbcursor( core00,&tb_cursor_font,&tb_cursor_mask,BLACK,WHITE );

			while(sts!=1)  
			{    
				sts = TKevent(root);   
			}  
		} 
		TKexit(root); 
	} 
} 
/************************************************************************
*		Module Name	: 													*
*************************************************************************/
int		pr_panel_exit( core )
	Ktcore	*core;
{
	int		sts = 0;

	if( fl_change == ON )
	{
		pr_end_panel_open();
		sts = -1;
	}
	return( sts );
}
/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

int		pr_graph_disp_button( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;

	if( event == ButtonRelease )
	{
		if( core_select == NULL )
		{
			panel01.wx = core->wx + 760;
			panel01.wy = core->wy + 110;
			core_select = (Ktcore *)TKopen( root, NULL, &panel01 );
			if( core_select != NULL )
			{
				TKentry( core_select, KARRAY, panel01_tree );
				TKchgbcursor( core_select,&tb_cursor_font,&tb_cursor_mask,BLACK,WHITE );
			}
		}
	}

	return( sts );
}

/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

int		pr_graph_redrow_button( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;

	if( event == ButtonRelease )
	{
		switch( graph_no )
		{
			case 1:
				pr_fukugou_redrow( item_no );
				break;
			case 2:
				pr_wari_redrow( item_no );
				break;
			case 3:
				pr_pay_redrow( item_no );
				break;
			case 4:
				pr_uri_redrow( item_no );
				break;
		}
	}
	return( sts );
}
/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

int		pr_graph_print_button( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;

	if( event == ButtonRelease )
	{
		pr_hc_start( core );
	}

	return( sts );
}
/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/
int		pr_hyou_end( core, table2, line, clum, type, text )
	Ktcore		*core;
	Kttable2	*table2;
	int			line;
	int			clum;
	int			type;
	char		*text;
{
	int		sts = 0;
	int		month;
	int		class;
	int		group;
	int		my;
	int		c, l;
	HDATA	*data;
	WEAR1	*wear = NULL;
	WEAR3	*wear3 = NULL;

	fl_change = ON;

#if 0
	c = clum - CELLTOPX;
	l = line - CELLTOPY;
	month = l;
	class = c / 12;
	group = ( c / 3 ) % 4;
	my = c % 3;

	switch( class )
	{
		case 0:
			wear = &hanbai[month].man;
			break;
		case 1:
			wear = &hanbai[month].wman;
			break;
		case 2:
			wear3 = &hanbai[month].child;
			break;
	}
	if( wear != NULL )
	{
		switch( group )
		{
			case 0:
				data = &wear->formal;
				break;
			case 1:
				data = &wear->cajual;
				break;
			case 2:
				data = &wear->other;
				break;
			case 3:
				break;
		}
	}else
	{
		switch( group )
		{
			case 0:
				data = &wear3->boy;
				break;
			case 1:
				data = &wear3->girl;
				break;
			case 2:
				data = &wear3->baby;
				break;
			case 3:
				break;
		}
	}

	if( group != 3 )
	{
		switch( my )
		{
			case 0:
				sscanf( text, "%d", &data->uriage );
				pr_rieki_calc( data );
				break;
			case 1:
				sscanf( text, "%d", &data->siharai );
				pr_rieki_calc( data );
				break;
			case 2:
				break;
		}
		if( my != 2 )
		{
			pr_hanbai_calc( class+2, month+1 );
			pr_table_data_change( core, line, clum, class, group, my, data );
		}
	}

#endif

	return( sts );
}
/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

void	pr_panel_right_down( panel )
	Ktpanel	*panel;
{
	panel->wx = root->rw - panel->ww - panel->bw *2;
	panel->wy = root->rh - panel->wh - panel->bw *2;
}
/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

void	pr_panel_center( panel )
	Ktpanel	*panel;
{
	panel->wx = root->rw / 2 - ( panel->ww + panel->bw )/2;
	panel->wy = root->rh / 2 - ( panel->wh + panel->bw )/2;
}

/************************************************************************
*		Module Name	:                                                 	*
*************************************************************************/

void	pr_other_button_off( core, buttons, button )
	Ktcore	*core;
	Ktbutn	**buttons;
	Ktbutn	*button;
{
	int		i;

	if( buttons != NULL )
	{
		for( i=0; buttons[i]!=NULL; i++ )
		{
			if( buttons[i]->hed.type == KOBUTN )
			{
				if( buttons[i] != button )
				{
					if( buttons[i]->flg == ON )
					{
						buttons[i]->flg = OFF;
						TKdisplay( core, KSINGL, buttons[i] );
					}
				}
			}
		}
	}
}
/************************************************************************
*		Module Name	: 													*
float	riekiritu( buy, pay )
	int		buy;
	int		pay;
{
	float	rieki;

	if( buy != 0 )
	{
		rieki = ( (float)buy - (float)pay ) / (float)buy * 100.0;
	}else
	{
		rieki = ( (float)buy - (float)pay );
	}

	return( rieki );
}
*************************************************************************/
/*************************************************************************      Module Name :                                                    **************************************************************************/
int pr_kobetu_button(core,button,event)

Ktcore  *core;
Ktbutn  *button;
int     event;
{
	int sts = 0;
	if(event == ButtonRelease)
	{
		if(core01 == NULL)
		{
			panel04.wx = 600;
			panel04.wy = 110;
			core01 = (Ktcore *)TKopen(root,NULL,&panel04);

			if(core01 != NULL)
			{
 				TKentry(core01,KARRAY,panel04_tree);
				TKnotify(core01,KEXIT,syokika);
			}
		}
	}
	return(sts);
}
/*************************************************************************     Module Name :                                                     **************************************************************************/
int sinsi_button(core,button,event)
 
Ktcore  *core;
Ktbutn  *button;
int     event;
{
    int sts = 0;
    if(event == ButtonRelease)
    {
        if(core02 == NULL)
        {
			TKclose(core01);
			core01 = NULL;
			tb_kobetu_button.flg = -1;
			tb_graph_disp_button.flg = -1;
			panel1.wx = 464;
			panel1.wy = 375;
            core02 = (Ktcore *)TKopen(root,NULL,&panel1);
 
            if(core02 != NULL)
            {
                TKentry(core02,KARRAY,panel1_tree);
				TKnotify(core02,KEXIT,k_button_2);
            }
        }
    }
	core02 = NULL;
    return(sts);
}
/*************************************************************************     Module Name :                                                     **************************************************************************/
int fujin_button(core,button,event)
 
Ktcore  *core;
Ktbutn  *button;
int     event;
{
    int sts = 0;
    if(event == ButtonRelease)
    {
        if(core03 == NULL)
        {   
			TKclose(core01);
			core01 = NULL;
			tb_kobetu_button.flg = -1;
			tb_graph_disp_button.flg = -1;
			panel2.wx = 464;
			panel2.wy = 375;
            core03 = (Ktcore *)TKopen(root,NULL,&panel2);
 
            if(core03 != NULL)
            {
                TKentry(core03,KARRAY,panel2_tree);
				TKnotify(core03,KEXIT,k_button_2);
            }
        }    
    }    
	core03 = NULL;
    return(sts);
}
/*************************************************************************     Module Name :                                                     **************************************************************************/  
int kodomo_button(core,button,event)  
   
Ktcore  *core;  
Ktbutn  *button;  
int     event;  
{  
    int sts = 0;  
    if(event == ButtonRelease)  
    {  
        if(core04 == NULL)  
        {     
			TKclose(core01);
			core01 = NULL;
			tb_kobetu_button.flg = -1;
			tb_graph_disp_button.flg = -1;
			panel3.wx = 464;
			panel3.wy = 375;
            core04 = (Ktcore *)TKopen(root,NULL,&panel3);  
   
            if(core04 != NULL)  
            {  
                TKentry(core04,KARRAY,panel3_tree);  
				TKnotify(core04,KEXIT,k_button_2);
            }  
        }      
    }      
	core04 = NULL;
    return(sts);  
}  
/*************************************************************************             k_button_2                                                **************************************************************************/ 
int k_button_2(core)

Ktcore   *core;
{
		tb_kobetu_button.flg = 0;
		TKdisplay(core00,KSINGL,&tb_kobetu_button);

		tb_graph_disp_button.flg = 0;
		TKdisplay(core00,KSINGL,&tb_graph_disp_button);

		return(0);
}
/*************************************************************************            syokika                                                    **************************************************************************/
int syokika(core)

Ktcore    *core;
{
		core01 = NULL;
		return(0);
}
 
